var express = require('express');
var http = require('express-graphql');
var { buildSchema } = require('graphql');

////////////////////////////////////////////////////////////////////////////////

class StatoServizio {

  constructor(){
     this.accessi=0
  }

  proverbioEmesso(proverbio){
    this.ultimo=proverbio
    this.accessi++
  }

}

class Archivio{

  constructor(proverbi){
      this.proverbi=proverbi
      this.stato=new StatoServizio()
  }

  proverbioRandom() {
    var item = this.proverbi[Math.floor(Math.random()*this.proverbi.length)];
    this.stato.proverbioEmesso(item)
    return item
  }

  nuovo(proverbio)
  {
     this.proverbi.push(proverbio)
     return this.proverbi.length
  }

  selezioneProverbi(quanti){
    if (quanti>0){
      return this.proverbi.slice(0, quanti)
    }
  }

}

////////////////////////////////////////////////////////////////////////////////

var def = buildSchema(`

  type StatoServizio{
    ultimo: String
    accessi: Int
  }

  type Query {
	   proverbioRandom: String
     stato: StatoServizio
     proverbi(quanti: Int): [String]
  }

  type Mutation{
     nuovo(nuovo: String): Int
  }
`);

archivio=new Archivio(['Gallina vecchia fa buon brodo',
                       'Il mattino ha l\'oro in bocca',
                       'Tra moglie e marito non mettere il dito',
                       'Una mela al giorno toglie il medico di torno',
                       'Ai pazzi si dà sempre ragione',
                       'Anno nuovo vita nuova',
                       'Bacco, tabacco e Venere riducon l\'uomo in cenere',
                       'Battere il ferro finché è caldo',
                       'Buon sangue non mente'])

var root = {
  // Query
  proverbioRandom: () =>
  {
	   return archivio.proverbioRandom()
  },
  stato: () => {
    return archivio.stato
  },
  proverbi: ({quanti}) => {
    return archivio.selezioneProverbi(quanti)
  },
  // Mutation
  nuovo: ({nuovo}) => {
      archivio.nuovo(nuovo);
      return archivio.proverbi.length
  }
};

var app = express();
app.use('/proverbi', http({
  schema: def,
  rootValue: root,
  graphiql: true,
}));
app.listen(8888);
console.log('Servizio in esecuzione su localhost:8888/proverbi');
